%% Compilation
% module detailed info
% build nodes
% slmodules
% build manually
% - makefile
% - build system
% build using spack
% ask us to build for you


\begin{frame}{Installing your own application}
  \begin{exampleblock}{You do it}
    \begin{itemize}
    \item Advanced uses of \code{modules} and \code{slmodules}
    \item Build nodes
    \item Compile your own code
    \end{itemize}
  \end{exampleblock}
  \begin{block}{We do it}
    \begin{itemize}
    \item Code useful for more than one user
    \item We need to know the different useful flavors
    \item We use/write a \code{spack} package and deploy it
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[fragile]{Advanced uses of \code{modules}}
  \begin{block}{Get more info on a module}
    \small
    \begin{lstlisting}[style=myshell,gobble=6,xleftmargin=0cm,xrightmargin=0cm]
      $ module load gcc
      $ module show openblas
      -------------------------------------------------------------------
         /ssoft/.../openblas/0.2.19.lua:
      -------------------------------------------------------------------
      whatis("Name : openblas")
      whatis("Version : 0.2.19")
      whatis("Short description : OpenBLAS: An optimized BLAS library")
      help([[OpenBLAS: An optimized BLAS library]])
      setenv("LMOD_LAPACK_NAME","openblas")
      setenv("LMOD_LAPACK_VERSION","0.2.19")
      prepend_path("PATH","/ssoft/.../openblas-0.2.19/bin")
      prepend_path("LD_LIBRARY_PATH","/ssoft/.../openblas-0.2.19/lib")
      setenv("OPENBLAS_ROOT","/ssoft/.../openblas-0.2.19")
    \end{lstlisting}
  \end{block}
\end{frame}

\begin{frame}[fragile]{Advanced uses of \code{modules}}
  \begin{block}{Modules releases and architectures}
    \begin{itemize}
    \item Releases: deprecated, stable, (future)
    \item Architectures:
      \begin{itemize}
%      \item deneb serial: x86\_E5v2
      \item deneb: x86\_E5v2\_IntelIB
      \item deneb gpu: x86\_E5v2\_Mellanox\_GPU
      \item eltanin: x86\_E5v3\_IntelIB
      \item fidis: x86\_E5v4\_Mellanox
      \item gacrux: x86\_S6g1\_Mellanox
      \end{itemize}
    \end{itemize}
  \end{block}

  \begin{exampleblock}{Automatically set on nodes}
    \small
    \begin{lstlisting}[style=myshell,gobble=6,%
                       xleftmargin=0cm,xrightmargin=0cm,
                       emph={stable,x86_E5v4_Mellanox},
                       emphstyle={\bf\color{BrickRed}}]
      $ module av
      -- /ssoft/spack/stable/v1/share/spack/lmod/linux-rhel7-x86_E5v4_Mellanox/Core --
      $ echo $SYS_TYPE
      x86_E5v4_Mellanox
    \end{lstlisting}
  \end{exampleblock}
\end{frame}

\begin{frame}{Advanced uses of modules}
  \begin{exampleblock}{Exercise}
    \begin{itemize}
    \item From deneb check the path where is openblas installed
    \item Try the same thing from fidis
    \end{itemize}
  \end{exampleblock}
\end{frame}

\begin{frame}{Compiling a code using modules}
  \begin{block}{Makefiles or by hand}
    \begin{itemize}
    \item \lstinline[style=myshell]{-I\$\{<MODULE>_ROOT\}/include}
    \item \lstinline[style=myshell]{-L$\{<MODULE>_ROOT\}/lib -l<library>}
    \end{itemize}
  \end{block}

  \begin{block}{configure}
    \begin{itemize}
    \item \lstinline[style=myshell]{--with-<module>=\$\{<MODULE>_ROOT\}}
    \end{itemize}
  \end{block}

  \begin{block}{cmake projects}
    \begin{itemize}
    \item Works out of the box if project correctly written
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}{Compiling a code using modules}
  \begin{exampleblock}{Exercise}
    \begin{itemize}
    \item Check the dgemm code in the example directory
    \item Load a compiler and a blas library (gcc, openblas) or (intel, intel-mkl)
    \item Compile with the makefile
    \item Create a build folder and compile using cmake
    \end{itemize}
  \end{exampleblock}
\end{frame}

\begin{frame}{Compiling for different architectures}
  \begin{block}{Use a build node}
    \lstinline[style=myshell]{Sinteract -s <arch> -p build}

    example on from fidis to access gacrux build node:
    \lstinline[style=myshell]{Sinteract -s s6g1 -p build}
  \end{block}

  \begin{block}{From the login node using \code{slmodules}}
    \begin{itemize}
    \item Select version:\\
      \lstinline[style=myshell]{slmodules -r future}
    \item Select architecture:\\
      \lstinline[style=myshell]{slmodules -s x86_S6g1_Mellanox}
    \end{itemize}
  \end{block}

  \begin{alertblock}{Organization is key}
    \begin{itemize}
    \item create a folder per machine
    \item you can use \lstinline[style=myshell]{\$\{SYS_TYPE\}}
    \end{itemize}
  \end{alertblock}
\end{frame}

\begin{frame}{Using \code{spack}}
  \begin{block}{Package manager for supercomputers: demo}
    \begin{itemize}
    \item \lstinline[style=myshell]{spack list fftw}
    \item \lstinline[style=myshell]{spack info fftw}
    \item \lstinline[style=myshell]{spack spec fftw}
    \item \lstinline[style=myshell]{spack install fftw}
    \end{itemize}
  \end{block}
\end{frame}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "slides"
%%% End:
